<?php

namespace Drupal\Tests\acquia_contenthub\Kernel;

/**
 * Class UserImportExportTest.
 *
 * @group acquia_contenthub
 *
 * @package Drupal\Tests\acquia_contenthub\Kernel
 */
class UserImportExportTest extends ImportExportTestBase {

  protected $fixtures = [
    [
      'cdf' => 'user.json',
      'expectations' => 'expectations/user.php',
    ],
    [
      'cdf' => 'node_page.json',
      'expectations' => 'expectations/node_page_user.php',
    ]
  ];

  /**
   * {@inheritdoc}
   */
  public static $modules = [
    'system',
    'user',
    'field',
    'depcalc',
    'acquia_contenthub',
  ];

  protected function setUp() {
    parent::setUp();
    $this->installEntitySchema('user');
  }

  /**
   * @dataProvider userImportExportDataProvider
   */
  public function testUserImportExport($delta, $validate_data, $export_type, $export_uuid) {
    parent::contentEntityImportExport($delta, $validate_data, $export_type, $export_uuid);
  }

  /**
   * Data provider for testUserImport.
   *
   * @return array
   */
  public function userImportExportDataProvider() {
    return [
      [0, [['type' => 'user', 'uuid' => 'f150c156-ef63-4f08-8d69-f15e5ee11106']], 'user', 'f150c156-ef63-4f08-8d69-f15e5ee11106'],
      [1, [['type' => 'user', 'uuid' => '8aa0ff11-1f3d-423e-84ac-f3ef22b10f81']], 'node', '38f023d8-b0d8-4e8c-9c06-8b547d8a0a85'],
    ];
  }

}
